#!/usr/bin/wish
#-------------------------------------------------------------------------------
# Calc - a very basic Tcl/Tk calculator
#-------------------------------------------------------------------------------
# Copyright (C) 1997 by James MacKay
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# The author can be contacted via e-mail at: jmackay@sentex.net
#--------------------------------------------------------------------------

# get the number of significant digits used by the calculator from the
# 'precision' applet parameter (default is 15):
#set tcl_precision \
#   [expr {[info exists embed_args(precision)] ? $embed_args(precision) : 15}]

# build the calculator UI: the question entry box (.q), the equals sign label
# (.e) and the answer label (.a)
entry .q -textvar q -bg #aabbcc
label .e -text "=" -padx 2
label .a -textvar a -width [expr {$tcl_precision + 5}] -bg #aabbcc

# pack the answer label first so that it isn`t clipped when the applet is too
# small:
pack .a .e -side right
pack .q -side left -fill x -expand true

bind .q <Return> {calc}

#-------------------------------------------------------------------------------
# Do the calculation: set a to the value of the expression $q, or "ERR" if $q 
# isn`t a valid Tcl math expression. Also selects the question iff a calculation
# was done.
#-------------------------------------------------------------------------------
proc calc {} {
   global q a .q

   if {[string compare $q ""] == 0} {return}
   if [catch {expr $q} a] {set a "ERR"}
   .q select range 0 end
   }





